#pragma once

#include "Participants/ParticipantUDP.h"

namespace RoboidControl {
namespace Posix {

class ParticipantUDP : public RoboidControl::ParticipantUDP {
 public:
  void Setup(int localPort, const char* remoteIpAddress, int remotePort);
  void SetupTCP(const char* remoteIpAddress, int remotePort);

  void Receive();
  int ReceiveTCP();
  bool Send(Participant* remoteParticipant, int bufferSize);
  bool SendTCP(int bufferSize);
  bool Publish(IMessage* msg);

 protected:
#if defined(__unix__) || defined(__APPLE__)
  sockaddr_in remote_addr;
  sockaddr_in server_addr;
  sockaddr_in broadcast_addr;
#endif
};

}  // namespace Posix
}  // namespace RoboidControl
